[oe-commits] org.oe.dev initscripts: Add custom checkroot.sh for logicpd-pxa270

cbrake commit openembedded-commits at lists.openembedded.org
Fri Oct 20 17:39:15 UTC 2006


initscripts: Add custom checkroot.sh for logicpd-pxa270
init script needs to be looking for /dev/root instead of rootfs to determine
if the rootfs has been mounted rw yet.  This may be a setup issue in the
kernel build, but until we can figure that out, this is the workaround.

Author: cbrake at openembedded.org
Branch: org.openembedded.dev
Revision: 83c4f209d12306d38f3b5bdb26e65c3a97013417
ViewMTN: http://monotone.openembedded.org/revision.psp?id=83c4f209d12306d38f3b5bdb26e65c3a97013417
Files:
1
packages/initscripts/initscripts-1.0/logicpd-pxa270
packages/initscripts/initscripts-1.0/logicpd-pxa270/checkroot.sh
packages/initscripts/initscripts_1.0.bb
Diffs:

#
# mt diff -r0b255384e65233702cb83a577326e1f35d1ed049 -r83c4f209d12306d38f3b5bdb26e65c3a97013417
#
# 
# 
# add_dir "packages/initscripts/initscripts-1.0/logicpd-pxa270"
# 
# add_file "packages/initscripts/initscripts-1.0/logicpd-pxa270/checkroot.sh"
#  content [899533d6aa3eb99220d09431f9fac2615d5f7c9d]
# 
# patch "packages/initscripts/initscripts_1.0.bb"
#  from [978637b6a0ebc5e2db2d16a71aace31f5d24e430]
#    to [8888dafb5c555df1b36a0ca9f10092423ada2862]
# 
============================================================
--- packages/initscripts/initscripts-1.0/logicpd-pxa270/checkroot.sh	899533d6aa3eb99220d09431f9fac2615d5f7c9d
+++ packages/initscripts/initscripts-1.0/logicpd-pxa270/checkroot.sh	899533d6aa3eb99220d09431f9fac2615d5f7c9d
@@ -0,0 +1,179 @@
+#
+# checkroot.sh	Check to root filesystem.
+#
+# Version:	@(#)checkroot.sh  2.84  25-Jan-2002  miquels at cistron.nl
+#
+
+. /etc/default/rcS
+
+#
+# Set SULOGIN in /etc/default/rcS to yes if you want a sulogin to be spawned
+# from this script *before anything else* with a timeout, like SCO does.
+#
+test "$SULOGIN" = yes && sulogin -t 30 $CONSOLE
+
+#
+# Ensure that bdflush (update) is running before any major I/O is
+# performed (the following fsck is a good example of such activity :).
+#
+test -x /sbin/update && update
+
+#
+# Read /etc/fstab.
+#
+exec 9>&0 </etc/fstab
+
+rootmode=rw
+rootopts=rw
+rootcheck=no
+swap_on_md=no
+devfs=
+while read fs mnt type opts dump pass junk
+do
+	case "$fs" in
+		""|\#*)
+			continue;
+			;;
+		/dev/md*)
+			# Swap on md device.
+			test "$type" = swap && swap_on_md=yes
+			;;
+		/dev/*)
+			;;
+		*)
+			# Might be a swapfile.
+			test "$type" = swap && swap_on_md=yes
+			;;
+	esac
+	test "$type" = devfs && devfs="$fs"
+	test "$mnt" != / && continue
+	rootopts="$opts"
+	test "$pass" = 0 -o "$pass" = "" && rootcheck=no
+	case "$opts" in
+		ro|ro,*|*,ro|*,ro,*)
+			rootmode=ro
+			;;
+	esac
+done
+
+exec 0>&9 9>&-
+
+
+#
+# Activate the swap device(s) in /etc/fstab. This needs to be done
+# before fsck, since fsck can be quite memory-hungry.
+#
+doswap=no
+test -d /proc/1 || mount -n /proc
+
+case "`uname -r`" in
+	2.[0123].*)
+		if test $swap_on_md = yes && grep -qs resync /proc/mdstat
+		then
+			test "$VERBOSE" != no && echo "Not activating swap - RAID array resyncing"
+		else
+			doswap=yes
+		fi
+		;;
+	*)
+		doswap=yes
+		;;
+esac
+if test $doswap = yes
+then
+	test "$VERBOSE" != no && echo "Activating swap"
+	swapon -a 2> /dev/null
+fi
+
+#
+# Check the root filesystem.
+#
+if test -f /fastboot || test $rootcheck = no
+then
+  test $rootcheck = yes && echo "Fast boot, no filesystem check"
+else
+  #
+  # Ensure that root is quiescent and read-only before fsck'ing.
+  #
+
+  mount -n -o remount,ro /
+
+  if test $? = 0
+  then
+    if test -f /forcefsck
+    then
+	force="-f"
+    else
+	force=""
+    fi
+    if test "$FSCKFIX" = yes
+    then
+	fix="-y"
+    else
+	fix="-a"
+    fi
+    spinner="-C"
+    case "$TERM" in
+        dumb|network|unknown|"") spinner="" ;;
+    esac
+    test `uname -m` = s390 && spinner="" # This should go away
+    test "$VERBOSE" != no && echo "Checking root filesystem..."
+    fsck $spinner $force $fix /
+    #
+    # If there was a failure, drop into single-user mode.
+    #
+    # NOTE: "failure" is defined as exiting with a return code of
+    # 2 or larger.  A return code of 1 indicates that filesystem
+    # errors were corrected but that the boot may proceed.
+    #
+    if test "$?" -gt 1
+    then
+      # Surprise! Re-directing from a HERE document (as in
+      # "cat << EOF") won't work, because the root is read-only.
+      echo
+      echo "fsck failed.  Please repair manually and reboot.  Please note"
+      echo "that the root filesystem is currently mounted read-only.  To"
+      echo "remount it read-write:"
+      echo
+      echo "   # mount -n -o remount,rw /"
+      echo
+      echo "CONTROL-D will exit from this shell and REBOOT the system."
+      echo
+      # Start a single user shell on the console
+      /sbin/sulogin $CONSOLE
+      reboot -f
+    fi
+  else
+    echo "*** ERROR!  Cannot fsck root fs because it is not mounted read-only!"
+    echo
+  fi
+fi
+
+#
+#	If the root filesystem was not marked as read-only in /etc/fstab,
+#	remount the rootfs rw but do not try to change mtab because it
+#	is on a ro fs until the remount succeeded. Then clean up old mtabs
+#	and finally write the new mtab.
+#	This part is only needed if the rootfs was mounted ro.
+#
+
+if [ $(grep "/dev/root" /proc/mounts | awk '{print $4}') = rw ]; then
+	exit 0
+fi
+
+echo "Remounting root file system..."
+mount -n -o remount,$rootmode /
+
+if test "$rootmode" = rw
+then
+	if test ! -L /etc/mtab
+	then
+		rm -f /etc/mtab~ /etc/nologin
+		: > /etc/mtab
+	fi
+	mount -f -o remount /
+	mount -f /proc
+	test "$devfs" && grep -q '^devfs /dev' /proc/mounts && mount -f "$devfs"
+fi
+
+: exit 0
============================================================
--- packages/initscripts/initscripts_1.0.bb	978637b6a0ebc5e2db2d16a71aace31f5d24e430
+++ packages/initscripts/initscripts_1.0.bb	8888dafb5c555df1b36a0ca9f10092423ada2862
@@ -5,7 +5,7 @@ LICENSE = "GPL"
 DEPENDS_openzaurus = "makedevs virtual/kernel"
 RDEPENDS = "makedevs"
 LICENSE = "GPL"
-PR = "r75"
+PR = "r76"
 
 SRC_URI = "file://halt \
            file://ramdisk \






More information about the Openembedded-commits mailing list